/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _AUXV_H
#define _AUXV_H

#define AT_NULL     0   /* end of vector */
#define AT_IGNORE   1   /* entry should be ignored */
#define AT_EXECFD   2   /* file descriptor of program */
#define AT_PHDR     3   /* program headers for program */
#define AT_PHENT    4   /* size of program header entry */
#define AT_PHNUM    5   /* number of program headers */
#define AT_PAGESZ   6   /* system page size */
#define AT_BASE     7   /* base address of interpreter */
#define AT_FLAGS    8   /* flags */
#define AT_ENTRY    9   /* entry point of program */
#define AT_NOTELF   10  /* program is not ELF */
#define AT_UID      11  /* real uid */
#define AT_EUID     12  /* effective uid */
#define AT_GID      13  /* real gid */
#define AT_EGID     14  /* effective gid */
#define AT_PLATFORM 15  /* string identifying CPU for optimizations */
#define AT_HWCAP    16  /* arch dependent hints at CPU capabilities */
#define AT_CLKTCK   17  /* frequency at which times() increments */

#define AT_SECURE   23  /* secure mode boolean */

#define AT_SYSINFO  32
#define AT_SYSINFO_EHDR 33

#define AT_VECTOR_SIZE 44 /* Size of auxiliary table.  */

#endif
