/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _BIN_H
#define _BIN_H

#define BIN_MAGIC 0xf9618723

#define BIN_NAME_LEN 16 /* 15 caracteres + zero terminal */

#define bin_align(n) (((n) + (sizeof (void *) - 1)) & ~(sizeof (void *) - 1))

typedef struct __attribute__ ((packed)) {
  unsigned long magic;
  unsigned long size;
  char name[BIN_NAME_LEN];
  unsigned long reserved;
  unsigned long checksum;
} bin_hdr_t;

#endif
