/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef TTY_H
#define TTY_H

struct tty_struct;

void tty_init(struct tty_struct *tty, unsigned long iflags, unsigned long oflags, unsigned long lflags, const unsigned char cc[], unsigned int column);

int tty_do_ioctl(struct tty_struct *tty, int request, void *fs_arg);

void tty_put(struct tty_struct *tty, char c);
void tty_process_input_queue(struct tty_struct *tty);
void tty_stop(struct tty_struct *tty);
void tty_start(struct tty_struct *tty);

int tty_read(struct tty_struct *tty, char *fs_buf, unsigned int count);
int tty_write(struct tty_struct *tty, const char *fs_buf, unsigned int count);
int tty_ioctl(struct tty_struct *tty, int request, void *fs_arg);

#endif
