/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VC_H
#define VC_H

struct vc_struct;
struct tty_queue_struct;
struct tty_struct;

void vc_init(struct vc_struct *vc, unsigned short line, unsigned short col);

void vc_tty_do_output(struct tty_struct *tty, struct tty_queue_struct *tty_queue);
void vc_tty_do_stop(struct tty_struct *tty);
void vc_tty_do_start(struct tty_struct *tty);
int vc_tty_do_ioctl(struct tty_struct *tty, int request, void *fs_arg);

void vc_history_up(const struct vc_struct *vc);
void vc_history_down(const struct vc_struct *vc);
void vc_history_pgup(const struct vc_struct *vc);
void vc_history_pgdn(const struct vc_struct *vc);
void vc_history_cancel(const struct vc_struct *vc);

#endif
