/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VC_STRUCT_H
#define VC_STRUCT_H

#include "tty_struct.h"
#include "vt_struct.h"

/* touches de controle */
#define SHIFT       001
#define CTRL        002
#define ALTGR       004
#define ALT         010

/* leds */
#define SCROLL_LOCK 001
#define NUM_LOCK    002
#define CAPS_LOCK   004

struct vc_struct;

struct vc_vtbl_struct {
  void (*do_stopped_changed)(struct vc_struct *vc);
};

struct vc_struct {

  /* structure de base, public */
  struct tty_struct tty;

  const struct vc_vtbl_struct *vptr;

  /* protected */

  struct vt_struct vt;              /* pilote du terminal video */

  /* public */

  unsigned char modifiers;          /* responsabilite du pilote de clavier */
  unsigned char lockstate;          /* responsabilite du pilote de clavier */
};

#endif
