/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VIDEO_DRIVER_H
#define VIDEO_DRIVER_H

struct attr_mode_struct;

/* interface de pilote video */
struct video_driver_struct {
  unsigned short (*get_lines)();
  unsigned short (*get_columns)();

  unsigned char (*get_cursor_type)();
  void (*set_cursor_type)(unsigned char type);
  unsigned short (*get_cursor_pos)();
  void (*set_cursor_pos)(unsigned short pos);

  void (*set_attr)(const struct attr_mode_struct *attr_mode);
  void (*putc)(unsigned short pos, unsigned char c);
  void (*clear)(unsigned short start, unsigned short end);
  void (*scroll)();

  void (*history_scroll)(short n);
  void (*history_cancel)();
};

#endif
