/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VT_STRUCT_H
#define VT_STRUCT_H

#include "attr_mode.h"

struct vt_struct {

  /* private */

  /* dimensions de l'ecran */
  unsigned short lines;
  unsigned short columns;

  /* parametres lies a l'affichage */
  unsigned short           line, saved_line; /* ligne du curseur */
  unsigned short           col, saved_col;   /* colonne du curseur */
  struct attr_mode_struct  attr_mode, saved_attr_mode; /* attributs */
  const unsigned char     *translation_table, *saved_translation_table; /* table de conversion des caracteres */

  /* etat */
  unsigned                 need_wrap : 1;    /* passer a la ligne au prochain caractere */
  int                      state;            /* etat de l'automate */
  int                      param[16];        /* parametres des sequences de controle */
  int                      npar;             /* nombre de parametres renseignes */
  int                      ques;             /* '?' dans la sequence de controle */

  /* modes */
  unsigned                 auto_wrap : 1;    /* passage a la ligne automatique */

  /* protected */

  /* interfaces d'acces aux pilotes */
  void (*do_kb_reset)();                     /* clavier */
  const struct video_driver_struct *driver;  /* video */
  void (*do_beep)();                         /* bip */
};

#endif
