/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef DEVICE_STRUCT_H
#define DEVICE_STRUCT_H

struct device_struct {
  int id;                       /* DEV_XXX */
  const char *name;
  int type;                     /* FT_CHR ou FT_BLK */

  union {
    /* FT_BLK */
    struct {
      /* pilote */
      const struct block_driver_struct *block_driver;

      /* montage */
      const struct file_system_struct *file_system;
      void *data;
      unsigned int count;       /* nombre de fois que le peripherique est monte */
    };
  };
};

#endif
