/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef FILE_H
#define FILE_H

struct file_struct;
struct stat_struct;

/* operations sur les fichiers */
int file_read(struct file_struct *file, unsigned long *pos, char *fs_buf, unsigned int count);
int file_write(struct file_struct *file, unsigned long *pos, const char *fs_buf, unsigned int count);
long file_seek(const struct file_struct *file, unsigned long *pos, long offset, int whence);
int file_stat(const struct file_struct *file, struct stat_struct *fs_buf);
int file_ioctl(const struct file_struct *file, int request, void *fs_arg);

#endif
