/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef FILE_SYSTEM_INSTANCE_H
#define FILE_SYSTEM_INSTANCE_H

struct file_system_instance_struct;
struct file_system_struct;
struct file_struct;
struct device_struct;

int file_system_instance_init(struct file_system_instance_struct *file_system_instance, const struct file_system_struct *file_system, const char *device_path, struct device_struct *device, const struct file_struct *mount_point);
void file_system_instance_destroy(struct file_system_instance_struct *file_system_instance);

void file_system_instance_hold(struct file_system_instance_struct *file_system_instance);
void file_system_instance_release(struct file_system_instance_struct *file_system_instance);
int file_system_instance_is_busy(const struct file_system_instance_struct *file_system_instance);

int print_mounts(char *buf, unsigned int size);

#endif
