/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef FILE_SYSTEM_INSTANCE_STRUCT_H
#define FILE_SYSTEM_INSTANCE_STRUCT_H

struct file_system_instance_struct {
  const struct file_system_struct *file_system;
  char *device_path;
  union {
    struct {                        /* file_system->type == FT_BLK */
      struct device_struct *device;
    };
  };
  void *data;
  unsigned int count;               /* nombre de references */

  const struct file_struct *mount_point;

  struct file_system_instance_struct *previous;
  struct file_system_instance_struct *next;
};

#endif
