/* Allocateur de fichiers */
/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "file_struct.h"

#include <slab.h>
#include <cache_struct.h>

/* cache de fichiers */
static struct cache_struct file_cache;

void file_table_init()
{
  kmem_cache_init(&file_cache, sizeof (struct file_struct));
}

void file_table_print_info() {}

struct file_struct *alloc_file()
{
  return kmem_cache_alloc(&file_cache);
}

void free_file(struct file_struct *file)
{
  kmem_cache_free(&file_cache, file);
}
