/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef PFS_STRUCTS_H
#define PFS_STRUCTS_H

struct pfs_dir_entry_info_struct {
  unsigned long id;                             /* identifiant du fichier */
  const char *name;                             /* nom du fichier */
  int type;                                     /* type du fichier */

  char *name_ptr;                               /* pointeur vers un nom alloue avec kmalloc() */
  char name_buf[32];                            /* tampon pour les noms courts */
};

struct pfs_dir_entry_struct {
  struct pfs_dir_entry_info_struct info;

  struct pfs_dir_entry_struct *previous;        /* entree precedente dans le repertoire */
  struct pfs_dir_entry_struct *next;            /* entree suivante dans le repertoire */
};

struct pfs_dir_struct {
  struct pfs_dir_entry_struct *first_entry;     /* premiere entree du repertoire */
  struct pfs_dir_entry_struct *last_entry;      /* derniere entree du repertoire */
};

#endif
