/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VFAT_FAT_INFO_STRUCT_H
#define VFAT_FAT_INFO_STRUCT_H

#include <vfat.h>

/* Cette structure conserve des donnees constantes relatives a un systeme de
 * fichier FAT. Elle contient une image du secteur de boot et du BPB (Bios
 * Parameter Block) ainsi qu'un certain nombre de valeurs utiles precalculees.
 */
struct vfat_fat_info_struct {
  bootSector_t boot_sect;           /* Boot Sector / BPB */
  unsigned long RootDirSectors;     /* nombre de secteurs du repertoire racine */
  unsigned long FATSz;              /* nombre de secteurs occupes par une FAT */
  unsigned long TotSec;             /* nombre total de secteurs sur le volume */
  unsigned long FirstDataSector;    /* premier secteur de la zone de donnees */
  unsigned long DataSec;            /* nombre de secteurs dans la zone de donnees */
  unsigned long CountofClusters;    /* nombre de clusters */
  int FATType;                      /* type de FAT */
  unsigned long FirstRootDirSecNum; /* premier secteur du repertoire racine (FAT12, FAT16) */
};

#endif
