/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VFAT_ITER_H
#define VFAT_ITER_H

struct vfat_dir_iter_struct;
struct vfat_file_iter_struct;
struct vfat_instance_struct;

int vfat_init_dir_iter(struct vfat_dir_iter_struct *dir_iter, struct vfat_instance_struct *vfat_instance, unsigned long dir_ent_key);
void vfat_destroy_dir_iter(struct vfat_dir_iter_struct *dir_iter);
unsigned long vfat_get_dir_iter_dir_ent_key(const struct vfat_dir_iter_struct *dir_iter);
union vfat_dir_entry_union *vfat_get_dir_iter_dir_entry(const struct vfat_dir_iter_struct *dir_iter);
void vfat_dirty_dir_iter_buffer(const struct vfat_dir_iter_struct *dir_iter);
int vfat_next_dir_iter(struct vfat_dir_iter_struct *dir_iter);

int vfat_init_file_iter(struct vfat_file_iter_struct *file_iter, struct vfat_instance_struct *vfat_instance, unsigned long file_blk_key);
void vfat_destroy_file_iter(struct vfat_file_iter_struct *file_iter);
unsigned long vfat_get_file_iter_file_blk_size(const struct vfat_file_iter_struct *file_iter);
void *vfat_get_file_iter_file_blk_buffer(const struct vfat_file_iter_struct *file_iter);
void vfat_dirty_file_iter_buffer(const struct vfat_file_iter_struct *file_iter);
int vfat_next_file_iter(struct vfat_file_iter_struct *file_iter);

#endif
