/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef VFAT_ITER_STRUCT_H
#define VFAT_ITER_STRUCT_H

#include <vfat.h>

union vfat_dir_entry_union {
  directoryEntryStructure_t short_struct;
  longDirectoryEntryStructure_t long_struct;
};

/* iterateur sur les entrees de repertoire */
struct vfat_dir_iter_struct {
  struct vfat_instance_struct *vfat_instance;
  unsigned long dir_ent_key;
  void *buffer;
};

/* iterateur sur les "blocs" de fichiers */
struct vfat_file_iter_struct {
  struct vfat_instance_struct *vfat_instance;
  unsigned long file_blk_key;
  void *buffer;
};

#endif
