/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _FS_H
#define _FS_H

void fs_init();
void fs_print_info();

int fs_create(const char *fs_filename);
int fs_remove(const char *fs_filename);
int fs_mkdir(const char *fs_filename);
int fs_rmdir(const char *fs_filename);
int fs_rename(const char *fs_oldname, const char *fs_newname);
int fs_mount(const char *fs_device, const char *fs_dir, const char *fs_type);
int fs_umount(const char *fs_dir);

#endif
