/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _IT_STACK_STRUCTS_H
#define _IT_STACK_STRUCTS_H

struct interrupted_instruction_struct {
  unsigned long eip;
  unsigned short cs;
  unsigned long eflags;
  union {
    struct { /* changement de niveau de privilege */
      unsigned long esp;
      unsigned short ss;
    };
  };
};

struct registers_struct {
  unsigned long eax;
  unsigned long ebx;
  unsigned long ecx;
  unsigned long edx;
  unsigned long esi;
  unsigned long edi;
  unsigned long ebp;
  unsigned short ds;
  unsigned short es;
  unsigned short fs;
  unsigned short gs;
};

struct syscall_args_struct {
  unsigned long arg1;
  unsigned long arg2;
  unsigned long arg3;
  unsigned long arg4;
  unsigned long arg5;
  unsigned long arg6;
  struct interrupted_instruction_struct *interrupted_instruction;
  struct registers_struct *registers;
};

#endif
