/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _LIMITS_H
#define _LIMITS_H

#define CHAR_BIT        __CHAR_BIT__

#define MB_LEN_MAX      1

#define SCHAR_MIN       (-SCHAR_MAX - 1)
#define SCHAR_MAX       __SCHAR_MAX__

#define UCHAR_MAX       (SCHAR_MAX * 2 + 1)

#define CHAR_MIN        SCHAR_MIN
#define CHAR_MAX        SCHAR_MAX

#define SHRT_MIN        (-SHRT_MAX - 1)
#define SHRT_MAX        __SHRT_MAX__

#define USHRT_MAX       (SHRT_MAX * 2 + 1)

#define INT_MIN         (-INT_MAX - 1)
#define INT_MAX         __INT_MAX__

#define UINT_MAX        (INT_MAX * 2U + 1U)

#define LONG_MIN        (-LONG_MAX - 1L)
#define LONG_MAX        __LONG_MAX__

#define ULONG_MAX       (LONG_MAX * 2UL + 1UL)

#endif
