/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _MAPPING_H
#define _MAPPING_H

struct mapping_struct;

void mapping_init(struct mapping_struct *mapping);
void mapping_destroy(struct mapping_struct *mapping);
void mapping_copy(const struct mapping_struct *src, struct mapping_struct *dest);

unsigned long mapping_get_page_frame(const struct mapping_struct *mapping, unsigned long offset);
void mapping_set_page_frame(struct mapping_struct *mapping, unsigned long offset, unsigned long page_frame);
void mapping_delete_page_frame(struct mapping_struct *mapping, unsigned long offset, unsigned long page_frame);

#endif
