/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _RTC_STRUCTS_H
#define _RTC_STRUCTS_H

struct rtc_clock_struct {
  int sec;  /* secondes (0-59) */
  int min;  /* minutes (0-59) */
  int hour; /* heures (0-23) */
  int wday; /* jour de la semaine (0=dimanche) */
  int mday; /* jour du mois (1-31) */
  int mon;  /* mois (1-12) */
  int year; /* annee (1900-...) */
};

struct rtc_configuration_struct {
  /* equipement */
  unsigned floppy_drive_nr : 3;
  unsigned diskette_drive_0_type : 4;
  unsigned diskette_drive_1_type : 4;
  unsigned hard_disk_drive_0_type : 8;
  unsigned hard_disk_drive_1_type : 8;
  unsigned primary_display : 2;
  unsigned math_coprocessor : 1;

  /* memoire */
  unsigned short base_memory; /* en Ko */
  unsigned short extended_memory; /* en Ko */
};

#endif
