/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define MAGIC 0x1badb002
#define FLAGS 0x00010000

#define STACK_SIZE 4096

	.text

.globl _start
.type _start,@function
.align 4
_start:
	jmp	start

/* en-tete multiboot */
.align 4
multiboot_header:
	.long	MAGIC		/* magic */
	.long	FLAGS		/* flags */
	.long	-(MAGIC + FLAGS)	/* checksum */
	.long	multiboot_header	/* header_addr */
	.long	kernel_start	/* load_addr */
	.long	_edata		/* load_end_addr */
	.long	_end		/* bss_end_addr */
	.long	start		/* entry_addr */

start:
	/* initialisation de la pile */
	movl	$(stack + STACK_SIZE), %esp

	/* appel de main */
	jmp	main

	/* La pile utilisee pendant l'initialisation du systeme. */
	.lcomm	stack, STACK_SIZE

	.section .note.GNU-stack,"",%progbits
