/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef AUXILIARY_VECTOR_H
#define AUXILIARY_VECTOR_H

struct auxiliary_vector_struct {
  struct {
    unsigned program_header_table : 1;
    unsigned program_header_entry_size : 1;
    unsigned program_header_entry_number : 1;
    unsigned page_size : 1;
    unsigned interpreter_base_address : 1;
    unsigned program_entry_point : 1;
    unsigned not_elf : 1;
    unsigned vdso_entry_point : 1;
    unsigned vdso_elf_header : 1;
  } contents;
  unsigned long program_header_table;
  unsigned int program_header_entry_size;
  int program_header_entry_number;
  unsigned long page_size;
  unsigned long interpreter_base_address;
  unsigned long program_entry_point;
  unsigned long vdso_entry_point;
  unsigned long vdso_elf_header;
};

#endif
