/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <keyboard.h>
#include <panic.h>
#include <printk.h>
#include <errno.h>
#include <consts.h>

int reboot(int cmd)
{
  switch (cmd) {
  case RB_HALT:
    printk("System halted.\n");
    die();
  case RB_RESTART:
    printk("Restarting system...\n");
    kb_reboot();
  default:
    return -EINVAL;
  }
}
