/* Arret des processus */
/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "make_status.h"
#include "status.h"
#include "sched.h"
#include "proc_struct.h"

#include <asm.h>
#include <enums.h>

void stop(int sig)
{
  int intr;

  disable_intr(intr);
  sched_remove(current);
  current->state = PS_STOPPED;
  set_status(make_status(0, 0, sig));
  schedule();
  restore_intr(intr);
}

void stop_continue(struct proc_struct *proc)
{
  int intr;

  disable_intr(intr);
  proc->state = PS_RUNNING;
  set_status(make_status(0, 0, 0));
  sched_add(proc);
  restore_intr(intr);
}
