/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef IO_H
#define IO_H

struct stat_struct;

int do_open(const char *fs_filename, int flags);
int do_close(int fd);
int do_dup(int fd);
int do_dup2(int fd, int newfd);
int do_pipe(int fs_fd[2]);
int do_fcntl(int fd, int cmd, long arg);
int do_read(int fd, char *fs_buf, unsigned int count);
int do_write(int fd, const char *fs_buf, unsigned int count);
int do_seek(int fd, long offset, int whence);
int do_stat(int fd, struct stat_struct *fs_buf);
int do_ioctl(int fd, int request, void *fs_arg);
int do_create(const char *fs_filename);
int do_remove(const char *fs_filename);
int do_mkdir(const char *fs_filename);
int do_rmdir(const char *fs_filename);
int do_rename(const char *fs_oldname, const char *fs_newname);
int do_mount(const char *fs_device, const char *fs_dir, const char *fs_type);
int do_umount(const char *fs_dir);
int do_reboot(int cmd);
int do_gettime(long *fs_time);
int do_mmap(void *addr, unsigned int len, int prot, int fd, long off);
int do_munmap(void *addr, unsigned int len);
int do_mprotect(void *addr, unsigned int len, int prot);

#endif
