/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef PROC_H
#define PROC_H

struct syscall_args_struct;
struct utsname_struct;

void do_exit(int status) __attribute__ ((noreturn));
int do_fork(struct syscall_args_struct args);
int do_exec(struct syscall_args_struct args);
int do_getpid();
int do_getpgid();
int do_setpgid(int pid, int pgid);
int do_chdir(const char *fs_path);
int do_sbrk(int increment, void **fs_brk);
unsigned int do_sleep(unsigned int seconds);
int do_wait(int pid, int *fs_status, int options);
int do_kill(int pid, int sig);
int do_uname(struct utsname_struct *fs_name);

#endif
