/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef MEMORY_H
#define MEMORY_H

struct maps_struct;
struct file_struct;

int copy_memory(const struct maps_struct *maps, struct maps_struct *dest_maps, unsigned long *dest_page_directory, unsigned long start, unsigned long length);
int free_memory(struct maps_struct *maps, unsigned long start, unsigned long length);
int protect_memory(struct maps_struct *maps, unsigned long start, unsigned long length, int prot);
int verify_memory(const struct maps_struct *maps, unsigned long start, unsigned long length, int access);

int map_mem(struct maps_struct *maps, unsigned long start, unsigned long length, int prot, void *mem_start);
int map_anon(struct maps_struct *maps, unsigned long start, unsigned long length, int prot, int grows_down, const char *name);
int map_file(struct maps_struct *maps, unsigned long start, unsigned long length, int prot, struct file_struct *file, unsigned long offset);

#endif
