/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "lowmem.h"
#include "highmem.h"

unsigned long alloc_page_frame()
{
  return alloc_page_frame_highmem() ? : alloc_page_frame_lowmem();
}

void hold_page_frame(unsigned long page_frame)
{
  is_highmem(page_frame) ? hold_page_frame_highmem(page_frame) : hold_page_frame_lowmem(page_frame);
}

void release_page_frame(unsigned long page_frame)
{
  is_highmem(page_frame) ? release_page_frame_highmem(page_frame) : release_page_frame_lowmem(page_frame);
}

int is_page_frame_shared(unsigned long page_frame)
{
  return is_highmem(page_frame) ? is_page_frame_shared_highmem(page_frame) : is_page_frame_shared_lowmem(page_frame);
}
