/* Reference: RFC 1952 */
/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef GZIP_H
#define GZIP_H

/* Member header */
typedef struct __attribute__ ((packed)) {
  unsigned char id1;           /* identification 1 */
  unsigned char id2;           /* identification 2 */
  unsigned char cm;            /* compression method */
  struct {
    unsigned char ftext : 1;
    unsigned char fhcrc : 1;
    unsigned char fextra : 1;
    unsigned char fname : 1;
    unsigned char fcomment : 1;
    unsigned char reserved : 3;
  } flg;                       /* flags */
  unsigned long mtime;
  unsigned char xfl;
  unsigned char os;
} gzip_member_hdr_t;

/* Member trailer */
typedef struct __attribute__ ((packed)) {
  unsigned long crc32;         /* CRC-32 */
  unsigned long isize;         /* input size */
} gzip_member_tlr_t;

#endif
