/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

#define PRINT(cmd) (printf("%s\n", #cmd), (cmd));
#define TEST(cmd, exp_value) ({int res; res = (cmd); printf("%s: %d (%d): %s\n", #cmd, res, exp_value, res == (exp_value) ? "OK" : "ECHEC");});

int main()
{
  chdir("/floppy");

  PRINT(mkdir("temp", 0));
  PRINT(chdir("temp"));
  TEST(rmdir("."), -1); /* rfrenc */
  TEST(rmdir(".."), -1); /* rfrenc */
  PRINT(chdir(".."));
  TEST(rmdir("temp/.."), -1); /* rfrenc */
  TEST(rmdir("temp"), 0);

  PRINT(mkdir("temp", 0));
  TEST(rmdir("temp/.."), -1); /* rfrenc */
  PRINT(close(creat("temp/temp", 0)));
  TEST(rmdir("temp/."), -1); /* non vide */
  PRINT(remove("temp/temp"));
  TEST(rmdir("temp/."), 0);

  return 0;
}
