/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _ANSI_MATH_H
#define _ANSI_MATH_H

#define HUGE_VAL (__builtin_huge_val())

double acos(double x);
double asin(double x);
double atan(double x);
double atan2(double y, double x);

double cos(double x);
double sin(double x);
double tan(double x);

double cosh(double x);
double sinh(double x);
double tanh(double x);

double exp(double x);
double frexp(double x, int *exp);
double ldexp(double x, int n);
double log(double x);
double log10(double x);
double modf(double x, double *iptr);

double pow(double x, double y);
double sqrt(double x);

double ceil(double x) __attribute__ ((const));
double fabs(double x) __attribute__ ((const));
double floor(double x) __attribute__ ((const));
double fmod(double x, double y);

#endif
