/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _ANSI_STRING_H
#define _ANSI_STRING_H

#include <bits/stddef.h>
#include <bits/stdtypes.h>

void *memcpy(void *dest, const void *src, size_t n) __attribute__ ((nonnull (1, 2)));

void *memmove(void *dest, const void *src, size_t n) __attribute__ ((nonnull (1, 2)));

void *memset(void *s, int c, size_t n) __attribute__ ((nonnull (1)));

int memcmp(const void *s1, const void *s2, size_t n) __attribute__ ((pure, nonnull (1, 2)));

void *memchr(const void *s, int c, size_t n) __attribute__ ((pure, nonnull (1)));

char *strcpy(char *dest, const char *src) __attribute__ ((nonnull (1, 2)));
char *strncpy(char *dest, const char *src, size_t n) __attribute__ ((nonnull (1, 2)));

char *strcat(char *dest, const char *src) __attribute__ ((nonnull (1, 2)));
char *strncat(char *dest, const char *src, size_t n) __attribute__ ((nonnull (1, 2)));

int strcmp(const char *s1, const char *s2) __attribute__ ((pure, nonnull (1, 2)));
int strncmp(const char *s1, const char *s2, size_t n) __attribute__ ((pure, nonnull (1, 2)));

int strcoll(const char *s1, const char *s2) __attribute__ ((pure, nonnull (1, 2)));

size_t strxfrm(char *dest, const char *src, size_t n) __attribute__ ((nonnull (1, 2)));

char *strchr(const char *s, int c) __attribute__ ((pure, nonnull (1)));
char *strrchr(const char *s, int c) __attribute__ ((pure, nonnull (1)));

size_t strspn(const char *s, const char *accept) __attribute__ ((pure, nonnull (1, 2)));
size_t strcspn(const char *s, const char *reject) __attribute__ ((pure, nonnull (1, 2)));

char *strpbrk(const char *s, const char *accept) __attribute__ ((pure, nonnull (1, 2)));

char *strstr(const char *haystack, const char *needle) __attribute__ ((pure, nonnull (1, 2)));

char *strtok(char *str, const char *delim) __attribute__ ((nonnull (2)));

size_t strlen(const char *s) __attribute__ ((pure, nonnull (1)));

char *strerror(int errnum);

#endif
