/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _ANSI_TIME_H
#define _ANSI_TIME_H

#include <bits/time.h>
#include <bits/stddef.h>
#include <bits/stdtypes.h>

#define CLOCKS_PER_SEC 1000000l

struct tm {
  int tm_sec;   /* seconds after the minute (0 to 61) */
  int tm_min;   /* minutes after the hour (0 to 59) */
  int tm_hour;  /* hours since midnight (0 to 23) */
  int tm_mday;  /* day of the month (1 to 31) */
  int tm_mon;   /* months since January (0 to 11) */
  int tm_year;  /* years since 1900 */
  int tm_wday;  /* days since Sunday (0 to 6 Sunday=0) */
  int tm_yday;  /* days since January 1 (0 to 365) */
  int tm_isdst; /* Daylight Savings Time */
};

clock_t clock();

time_t time(time_t *tloc);

double difftime(time_t time1, time_t time0) __attribute__ ((const));

size_t strftime(char *s, size_t max, const char *format, const struct tm *tm) __attribute__ ((format (strftime, 3, 0)));

char *asctime(const struct tm *tm);
char *ctime(const time_t *timep);
struct tm *gmtime(const time_t *timep);
struct tm *localtime(const time_t *timep);
time_t mktime(struct tm *tm);

#endif
