/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _BITS_FCNTL_H
#define _BITS_FCNTL_H

#include <xos/fcntl.h>

/* mask for use with file access modes */
#define O_ACCMODE   03 /* mask for file access modes */

/* file access modes */
#define O_RDONLY    01 /* open for reading only */
#define O_WRONLY    02 /* open for writing only */
#define O_RDWR   (O_RDONLY | O_WRONLY) /* open for reading and writing */

/* file creation flags */
#define O_CREAT   0100 /* create file if it does not exist */
#define O_EXCL    0200 /* exclusive use flag */
#define O_TRUNC   0400 /* truncate flag */

/* file status flags */
#define O_APPEND 01000 /* set append mode */

#endif
