/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _BITS_TERMIOS_H
#define _BITS_TERMIOS_H

#include <xos/termios.h>

/* attribute selection */
#define TCSANOW   0 /* change attributes immediately */
#define TCSADRAIN 1 /* change attributes when output has drained */

typedef unsigned char cc_t;
typedef unsigned int tcflag_t;

struct termios {
  tcflag_t c_iflag;    /* input modes */
  tcflag_t c_oflag;    /* output modes */
  tcflag_t c_lflag;    /* local modes */
  cc_t     c_cc[NCCS]; /* control chars */
};

#endif
