/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _DIRENT_H
#define _DIRENT_H

#include <sys/types.h>

#include <bits/dirent.h>

typedef struct __DIR DIR;

DIR *opendir(const char *dirname) __attribute__ ((nonnull (1)));
DIR *fdopendir(int fd);

int closedir(DIR *dirp) __attribute__ ((nonnull (1)));

struct dirent *readdir(DIR *dirp) __attribute__ ((nonnull (1)));

void seekdir(DIR *dirp, long loc) __attribute__ ((nonnull (1)));
long telldir(DIR *dirp) __attribute__ ((nonnull (1)));
void rewinddir(DIR *dirp) __attribute__ ((nonnull (1)));

int dirfd(DIR *dirp) __attribute__ ((nonnull (1)));

#endif
