/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _GETOPT_H
#define _GETOPT_H

#define no_argument       0
#define required_argument 1
#define optional_argument 2

struct option {
  const char *name;
  int has_arg;
  int *flag;
  int val;
};

extern char *optarg;
extern int optind, opterr, optopt;

int getopt(int argc, char *argv[], const char *optstring);
int getopt_long(int argc, char *argv[], const char *optstring, const struct option *longopts, int *longindex);
int getopt_long_only(int argc, char *argv[], const char *optstring, const struct option *longopts, int *longindex);

#endif
