/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _HISTORY_H
#define _HISTORY_H

typedef void *histdata_t;

typedef struct _hist_entry {
  char *line;
  histdata_t data;
} HIST_ENTRY;

void using_history();
void add_history(const char *string);
HIST_ENTRY **history_list();
int where_history();
HIST_ENTRY *current_history();
int history_set_pos(int pos);
HIST_ENTRY *previous_history();
HIST_ENTRY *next_history();

#endif
