/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _STDINT_H
#define _STDINT_H

/* exact-width integer types */
typedef signed char    int8_t;   /* 8-bit signed integral type */
typedef short          int16_t;  /* 16-bit signed integral type */
typedef int            int32_t;  /* 32-bit signed integral type */
typedef unsigned char  uint8_t;  /* 8-bit unsigned integral type */
typedef unsigned short uint16_t; /* 16-bit unsigned integral type */
typedef unsigned int   uint32_t; /* 32-bit unsigned integral type */

/* integer types capable of holding object pointers */
typedef long int          intptr_t;  /* signed integral type large enough to
                                        hold any pointer */
typedef unsigned long int uintptr_t; /* unsigned integral type large enough to
                                        hold any pointer */

/* greatest-width integer types */
typedef long long int          intmax_t;  /* signed integral type large enough
                                             to hold any integer type */
typedef unsigned long long int uintmax_t; /* unsigned integral type large
                                             enough to hold any integer type */

#endif
