/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _STDIO_H
#define _STDIO_H

#include <ansi/stdio.h>

FILE *fdopen(int fd, const char *mode);

void setbuffer(FILE *stream, char *buf, size_t size);
void setlinebuf(FILE *stream);

int fileno(FILE *stream);

int snprintf(char *s, size_t size, const char *format, ...) __attribute__ ((format (printf, 3, 4)));
int vsnprintf(char *s, size_t size, const char *format, va_list ap) __attribute__ ((format (printf, 3, 0)));

int vscanf(const char *format, va_list ap) __attribute__ ((format (scanf, 1, 0)));
int vfscanf(FILE *stream, const char *format, va_list ap) __attribute__ ((format (scanf, 2, 0)));
int vsscanf(const char *s, const char *format, va_list ap) __attribute__ ((format (scanf, 2, 0)));

#endif
