/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _SYS_STAT_H
#define _SYS_STAT_H

#include <bits/stat.h>

#define S_ISFIFO(m) (((m) & S_IFMT) == S_IFIFO) /* test for a FIFO special
                                                   file */
#define S_ISCHR(m) (((m) & S_IFMT) == S_IFCHR)  /* test for a character special
                                                   file */
#define S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)  /* test for a directory */
#define S_ISBLK(m) (((m) & S_IFMT) == S_IFBLK)  /* test for a block special
                                                   file */
#define S_ISREG(m) (((m) & S_IFMT) == S_IFREG)  /* test for a regular file */

int stat(const char *path, struct stat *buf) __attribute__ ((nonnull (1, 2)));
int fstat(int fd, struct stat *buf) __attribute__ ((nonnull (2)));
int lstat(const char *path, struct stat *buf) __attribute__ ((nonnull (1, 2)));

int mkdir(const char *path, mode_t mode) __attribute__ ((nonnull (1)));

#endif
