/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _XOS_IO_H
#define _XOS_IO_H

#include <xos/seek.h>
#include <xos/fcntl.h>
#include <xos/termios.h>

#define _XOS_O_READ  0x1
#define _XOS_O_WRITE 0x2

#define _XOS_TGETIF   0x0001
#define _XOS_TSETIF   0x0002
#define _XOS_TGETOF   0x0003
#define _XOS_TSETOF   0x0004
#define _XOS_TGETLF   0x0005
#define _XOS_TSETLF   0x0006
#define _XOS_TGETCC   0x0007
#define _XOS_TSETCC   0x0008
#define _XOS_TGETPGID 0x0009
#define _XOS_TSETPGID 0x000a
#define _XOS_TGETWSZ  0x000b
#define _XOS_TGETCT   0x000c
#define _XOS_TSETCT   0x000d

#define _XOS_FT_NONE 0
#define _XOS_FT_DIR  1
#define _XOS_FT_CHR  2
#define _XOS_FT_BLK  3
#define _XOS_FT_REG  4
#define _XOS_FT_PIPE 5

#define _XOS_DEV_NONE    0
#define _XOS_DEV_FD      1
#define _XOS_DEV_CONSOLE 2
#define _XOS_DEV_NULL    3
#define _XOS_DEV_ZERO    4
#define _XOS_DEV_FULL    5

#define _XOS_RB_HALT    1
#define _XOS_RB_RESTART 2

struct _xos_stat_struct {
  int dev;
  unsigned long id;
  int type;
  int rdev;
  unsigned long size;
  long mtime;
};

struct _xos_winsize_struct {
  unsigned short height;
  unsigned short width;
};

#endif
