/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef _XOS_H
#define _XOS_H

#define SIGHUP         1        /* Hangup */
#define SIGINT         2        /* Interrupt */
#define SIGQUIT        3        /* Quit */
#define SIGILL         4        /* Illegal instruction */
#define SIGTRAP        5        /* Trace/breakpoint trap */
#define SIGABRT        6        /* Aborted */
#define SIGBUS         7        /* Bus error */
#define SIGFPE         8        /* Floating point exception */
#define SIGKILL        9        /* Killed */
#define SIGUSR1       10        /* User defined signal 1 */
#define SIGSEGV       11        /* Segmentation fault */
#define SIGUSR2       12        /* User defined signal 2 */
#define SIGPIPE       13        /* Broken pipe */
#define SIGALRM       14        /* Alarm clock */
#define SIGTERM       15        /* Terminated */
#define SIGSTKFLT     16        /* Stack fault */
#define SIGCHLD       17        /* Child exited */
#define SIGCONT       18        /* Continued */
#define SIGSTOP       19        /* Stopped (signal) */
#define SIGTSTP       20        /* Stopped */
#define SIGTTIN       21        /* Stopped (tty input) */
#define SIGTTOU       22        /* Stopped (tty output) */
#define SIGURG        23        /* Urgent I/O condition */
#define SIGXCPU       24        /* CPU time limit exceeded */
#define SIGXFSZ       25        /* File size limit exceeded */
#define SIGVTALRM     26        /* Virtual timer expired */
#define SIGPROF       27        /* Profiling timer expired */
#define SIGWINCH      28        /* Window changed */
#define SIGPOLL       29        /* I/O possible */
#define SIGPWR        30        /* Power failure */
#define SIGSYS        31        /* Bad system call */

#endif
