/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef LOAD_H
#define LOAD_H

#include "loaded_object_info.h"

#define LF_NOEXEC   0x1

struct object_info_struct;

void examine_executable(Elf32_Phdr *program_header_table, int program_header_count, void *entry_point, const char *invocation_name, struct loaded_object_info_struct *loaded_object_info);
void examine_dynamic_linker(Elf32_Phdr *program_header_table, int program_header_count, void *base_address, void *entry_point, struct loaded_object_info_struct *loaded_object_info);
void examine_vdso(void *load_address, struct loaded_object_info_struct *loaded_object_info);
void load_object_file(const char *filename, int flags, struct loaded_object_info_struct *loaded_object_info);

void make_segments_writable(struct object_info_struct *object_info);
void restore_segments_prot(struct object_info_struct *object_info);

#endif
