/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef UTIL_H
#define UTIL_H

#include "sysvars.h"

#define PAGE(addr)        ((addr) & ~(page_size - 1))
#define PAGE_ALIGN(addr)  PAGE((addr) + (page_size - 1))
#define PAGE_OFFSET(addr) ((addr) & (page_size - 1))

#define min(a, b) ({ \
  typeof (a) _a = (a); \
  typeof (b) _b = (b); \
  _a < _b ? _a : _b; \
})

#define roundup(x, y) ((y) * (((x) + ((y) - 1)) / (y)))

#endif
