/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "vars.h"

#include "initfini.h"
#include "object_info.h"
#include "loaded_object_info.h"

/* Environnement */

/* Chemins de recherche des bibliotheques partagees ou NULL. */
const char *library_path;

/* Object partage dynamique virtuel */

/* Informations sur l'objet partage dynamique virtuel. */
struct loaded_object_info_struct vdso_load_info;

/* Executable */

/* Nom de l'executable sur lequel l'editeur de liens dynamique a ete invoque.
 */
char *executable_invocation_name;

/* Informations sur l'executable. */
struct loaded_object_info_struct executable_load_info;

/* Editeur de liens dynamique */

/* Nom avec lequel l'editeur de liens dynamique a ete invoque s'il a ete
 * invoque explicitement, NULL sinon. */
char *dynamic_linker_invocation_name;

/* Informations sur l'editeur de liens dynamique. */
struct loaded_object_info_struct dynamic_linker_load_info;

/* Dependences */

/* Executable. */
struct object_info_struct executable_info;

/* Objets partages. */
struct object_info_list_struct shared_object_info_list;

/* Ordre d'initialisation des objets partages. */
struct initfini_list_struct shared_object_initfini_list;
