/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "init.h"

#include "getopt.h"
#include "time.h"
#include "environ.h"
#include "stdio.h"
#include "program_invocation_name.h"

void __libc_init(int argc, char **argv, char **envp)
{
  __set_program_invocation_name(argv[0]);
  environ = envp;

  __stdio_init();
  __environ_init();
  __tz_init();
  __getopt_init();
}

void __libc_fini()
{
  __environ_fini();
  __stdio_fini();
}
