/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/reboot.h>

#include "xos.h"

#include <errno.h>

int __attribute__ ((weak, visibility ("default"))) reboot(int cmd)
{
  switch (cmd) {
  case RB_AUTOBOOT:
    cmd = _XOS_RB_RESTART;
    break;
  case RB_HALT_SYSTEM:
    cmd = _XOS_RB_HALT;
    break;
  default:
    errno = EINVAL;
    return -1;
  }
  return __syscall_reboot(cmd);
}
