/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "ctor.h"
#include "init.h"

void _init(int argc, char **argv, char **envp);

void __attribute__ ((section (".init"))) _init(int argc, char **argv, char **envp)
{
  __libc_init(argc, argv, envp);

  call_ctors();
}

static void fini()
{
  call_dtors();

  __libc_fini();
}

static void (*fini_func)() __attribute__ ((used, section (".fini_array"))) = fini;
