/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "signal.h"

#include <stdio.h>
#include "unistd.h"
#include <errno.h>

void __attribute__ ((weak, visibility ("default"))) (*signal(int sig, void (*func)(int)))(int)
{
  errno = ENOSYS;
  return SIG_ERR;
}

int __attribute__ ((weak, visibility ("default"))) raise(int sig)
{
  return __kill(__getpid(), sig);
}

void __attribute__ ((weak, visibility ("default"))) psignal(int sig, const char *s)
{
  if (s && *s)
    fprintf(stderr, "%s: ", s);
  if (sig >= 0 && sig < sys_nsig && sys_siglist[sig])
    fprintf(stderr, "%s\n", sys_siglist[sig]);
  else
    fprintf(stderr, "Unknown signal %d\n", sig);
}
