/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <strings.h>

#include "ctype.h"

int __attribute__ ((weak, visibility ("default"))) strcasecmp(const char *s1, const char *s2)
{
  register int r;

  while ((r = __toupper((unsigned char)*s1) - __toupper((unsigned char)*s2)) == 0) {
    if (*s1++ == '\0')
      return 0;
    s2++;
  }
  return r;
}

int __attribute__ ((weak, visibility ("default"))) strncasecmp(const char *s1, const char *s2, size_t n)
{
  register int r;

  do {
    if ((r = __toupper((unsigned char)*s1) - __toupper((unsigned char)*s2)) != 0)
      return r;
    if (*s1++ == '\0')
      break;
    s2++;
  }
  while (--n);

  return 0;
}
