/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdlib.h>

#include <unistd.h>
#include <sys/wait.h>
#include <errno.h>

int __attribute__ ((weak, visibility ("default"))) system(const char *command)
{
  pid_t pid;
  int status;

  if (!(pid = fork())) {
    execl("/bin/xsh", "xsh", "-c", command ? : "", NULL);
    exit(127);
  }
  if (pid == -1)
    return -1;
  while (waitpid(pid, &status, 0) == -1)
    if (errno != EINTR)
      return -1;
  if (!command && WEXITSTATUS(status) == 127)
    return 0;
  else
    return status;
}
