/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/utsname.h>

#include "xos.h"

#include <string.h>

int __attribute__ ((weak, visibility ("default"))) uname(struct utsname *name)
{
  struct _xos_utsname_struct xos_name;

  if (__syscall_uname(&xos_name) == -1)
    return -1;
  strcpy(name->sysname, xos_name.sysname);
  strcpy(name->release, xos_name.release);
  strcpy(name->version, xos_name.version);
  strcpy(name->machine, xos_name.machine);
  return 0;
}
typeof (uname) __uname __attribute__ ((alias ("uname")));
