/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef EDIT_H
#define EDIT_H

struct linebuf_struct;

void begin_editing(const char *prompt, struct linebuf_struct *linebuf);
void replace_region_with_char(int start, int end, char c);
void replace_region_with_text(int start, int end, const char *text);
void erase_region(int start, int end);
void delete_region(int start, int end);
void move_to(int newpoint);
void set_mark(int newmark);
void exchange_point_and_mark();
void refresh_line();
void clear_screen();
void reset_line(struct linebuf_struct *linebuf);
void accept_line();
void abort_line();
void discard_line();
void end_editing();

#endif
