/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "common.h"

#include <error.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>

static int close_stream(FILE *stream)
{
  int err;

  fflush(stream);
  err = ferror(stream);
  fclose(stream);
  return err ? EOF : 0;
}

void close_stdout()
{
  if (close_stream(stdout) == EOF) {
    error(0, errno, "%s", "write error");
    _exit(EXIT_FAILURE);
  }

  if (close_stream(stderr) == EOF)
    _exit(EXIT_FAILURE);
}
