/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "common.h"

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

static void print_help()
{
  printf("Usage: %s [ignored command line arguments]\n", program_invocation_name);
  printf("  or:  %s OPTION\n", program_invocation_name);
  puts("Exit with a status code indicating success.");
  putchar('\n');
  puts("      --help  display this help and exit");
}

int main(int argc, char **argv)
{
  atexit(close_stdout);

  if (argc == 2)
    if (!strcmp(argv[1], "--help"))
      print_help();

  return EXIT_SUCCESS;
}
