/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef BUILTINS_H
#define BUILTINS_H

struct builtin_struct {
  const char *name;
  void (*print_usage)();
  void (*print_description)();
  int (*func)(int, char **);
};

extern const struct builtin_struct bg_builtin;
extern const struct builtin_struct cd_builtin;
extern const struct builtin_struct exit_builtin;
extern const struct builtin_struct fg_builtin;
extern const struct builtin_struct help_builtin;
extern const struct builtin_struct history_builtin;
extern const struct builtin_struct jobs_builtin;
extern const struct builtin_struct kill_builtin;
extern const struct builtin_struct wait_builtin;

extern const struct builtin_struct *builtin_table[];

#endif
