/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef ERROR_H
#define ERROR_H

#include <sys/types.h>

void sys_error(int errnum, const char *format, ...);
void fatal_error(const char *format, ...);

void generic_error(const char *format, ...);
void syntax_error(const char *format, ...);
void parse_error(const char *token);
void file_error(int errnum, const char *path);
void process_error(int errnum, pid_t pid);
void invalid_option_error(int opt);

#endif
