/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef FREE_CMD_H
#define FREE_CMD_H

struct argument_struct;
struct redirect_struct;
struct simple_command_struct;
struct compound_command_struct;
struct command_struct;
struct pipeline_struct;
struct and_or_list_struct;
struct list_struct;

void free_argument_list(struct argument_struct *first_argument);
void free_redirect_list(struct redirect_struct *first_redirect);
void free_command_list(struct command_struct *first_command);
void free_pipeline_list(struct pipeline_struct *first_pipeline);
void free_and_or_list_list(struct and_or_list_struct *first_and_or_list);

void free_argument(struct argument_struct *argument);
void free_redirect(struct redirect_struct *redirect);
void free_command(struct command_struct *command);
void free_pipeline(struct pipeline_struct *pipeline);
void free_and_or_list(struct and_or_list_struct *and_or_list);
void free_list(struct list_struct *list);

#endif
