/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "util.h"

#include "safe_malloc.h"
#include "error.h"

#include <limits.h>
#include <unistd.h>
#include <errno.h>

char *get_working_directory()
{
  char *buf;
  size_t size;

  buf = safe_malloc(PATH_MAX);
  size = PATH_MAX;
  while (!getcwd(buf, size)) {
    if (errno != ERANGE) {
      sys_error(errno, "error retrieving current directory");
      free(buf);
      return NULL;
    }
    buf = safe_realloc(buf, size * 2);
    size *= 2;
  }
  return buf;
}
