/* Copyright (C) 2008  Emmanuel Varoquaux

   This file is part of XOS.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "vars.h"

/* Non nul si l'interpreteur de commandes est interactif (par defaut s'il est
 * connecte a un terminal). */
int interactive;

/* Nom du script depuis lequel l'interpreteur de commandes lit les commandes.
 * Nul si les commandes ne sont pas lues depuis un fichier. */
char *script_name;

/* Numero de la ligne en cours. */
int line_number;

/* Si non nul, affiche le numero de ligne dans un message d'erreur. */
int print_line_number_on_error;

/* La commande interne en cours d'execution. */
const struct builtin_struct *current_builtin;

/* Code de retour de la derniere conduite executee. */
int last_command_status;

/* Repertoire de travail courant. */
char *pwd;

/* Repertoire de travail precedent. */
char *oldpwd;

/* Non nul si l'entree est un flux temporise. */
int buffered_input_stream;

/* Non nul pour quitter. */
int done;

/* Ligne de l'historique en construction lors de la lecture de commandes. */
char *history_line;
