<?xml version="1.0" encoding="ISO-8859-1"?>
<!--
Copyright (C) 2008  Emmanuel Varoquaux

This file is part of XOS.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" doctype-system="http://www.w3.org/TR/html4/loose.dtd"/>
<xsl:template match="/">
<html>
<head>
<meta http-equiv="Content-Language" content="fr"/>
<meta name="description" content="Le systme d'exploitation XOS"/>
<meta name="author" content="Emmanuel Varoquaux"/>
<meta name="date" content="$timestamp"/>
<link rel="stylesheet" href="css/layout.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="css/main.css" type="text/css" media="screen"/>
<title>
<xsl:choose>
<xsl:when test="/page/@id='index'">XOS</xsl:when>
<xsl:otherwise>XOS - <xsl:value-of select="/page/title"/></xsl:otherwise>
</xsl:choose>
</title>
</head>
<body>
<div id="header">
<a href=".">XOS</a>
<hr/>
</div>
<div id="body">
<div id="menu">
<ul>
<li>
<xsl:element name="a">
<xsl:attribute name="href">.</xsl:attribute>
<xsl:if test="/page/@id='index'">
<xsl:attribute name="class">current</xsl:attribute>
</xsl:if>
<xsl:text>Accueil</xsl:text>
</xsl:element>
</li>
<li>
<xsl:element name="a">
<xsl:attribute name="href">download.html</xsl:attribute>
<xsl:if test="/page/@id='download'">
<xsl:attribute name="class">current</xsl:attribute>
</xsl:if>
<xsl:text>Tlchargement</xsl:text>
</xsl:element>
</li>
<li>
<xsl:element name="a">
<xsl:attribute name="href">screenshots.html</xsl:attribute>
<xsl:if test="/page/@id='screenshots'">
<xsl:attribute name="class">current</xsl:attribute>
</xsl:if>
<xsl:text>Captures d'cran</xsl:text>
</xsl:element>
</li>
<li>
<xsl:element name="a">
<xsl:attribute name="href">install.html</xsl:attribute>
<xsl:if test="/page/@id='install'">
<xsl:attribute name="class">current</xsl:attribute>
</xsl:if>
<xsl:text>Installation</xsl:text>
</xsl:element>
</li>
<li>
<xsl:element name="a">
<xsl:attribute name="href">links.html</xsl:attribute>
<xsl:if test="/page/@id='links'">
<xsl:attribute name="class">current</xsl:attribute>
</xsl:if>
<xsl:text>Liens</xsl:text>
</xsl:element>
</li>
</ul>
<hr/>
</div>
<div id="content">
<xsl:copy-of select="/page/body/text/*"/>
<hr/>
</div>
</div>
<div id="footer">
<div id="valid">
<a href="http://validator.w3.org/check?uri=referer"><img src="images/valid-html401.png" border="0" width="88" height="31" alt="Valid HTML 4.01!" class="valid"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img src="images/valid-css.png" border="0" width="88" height="31" alt="Valid CSS!" class="valid"/></a>
</div>
<div id="about">
<xsl:text>Dernire mise  jour : $date - </xsl:text>
<a href="mailto:emmanuel.varoquaux@free.fr">Emmanuel Varoquaux &lt;emmanuel.varoquaux@free.fr&gt;</a>
</div>
</div>
</body>
</html>
</xsl:template>
</xsl:stylesheet>
